Skip to content
Start here

Update a User Agent Blocking rule

client.firewall.uaRules.update(stringuaRuleId, UARuleUpdateParams { zone_id, configuration, mode, 2 more } params, RequestOptionsoptions?): UARuleUpdateResponse { id, configuration, description, 2 more }
PUT/zones/{zone_id}/firewall/ua_rules/{ua_rule_id}

Updates an existing User Agent Blocking rule.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Firewall Services Write
ParametersExpand Collapse
uaRuleId: string

The unique identifier of the User Agent Blocking rule.

maxLength32
params: UARuleUpdateParams { zone_id, configuration, mode, 2 more }
zone_id: string

Path param: Defines an identifier.

maxLength32
configuration: AccessRuleIPConfiguration { target, value } | IPV6Configuration { target, value } | AccessRuleCIDRConfiguration { target, value } | 2 more

Body param: The rule configuration.

One of the following:
AccessRuleIPConfiguration { target, value }
target?: "ip"

The configuration target. You must set the target to ip when specifying an IP address in the rule.

value?: string

The IP address to match. This address will be compared to the IP address of incoming requests.

IPV6Configuration { target, value }
target?: "ip6"

The configuration target. You must set the target to ip6 when specifying an IPv6 address in the rule.

value?: string

The IPv6 address to match.

AccessRuleCIDRConfiguration { target, value }
target?: "ip_range"

The configuration target. You must set the target to ip_range when specifying an IP address range in the rule.

value?: string

The IP address range to match. You can only use prefix lengths /16 and /24 for IPv4 ranges, and prefix lengths /32, /48, and /64 for IPv6 ranges.

ASNConfiguration { target, value }
target?: "asn"

The configuration target. You must set the target to asn when specifying an Autonomous System Number (ASN) in the rule.

value?: string

The AS number to match.

CountryConfiguration { target, value }
target?: "country"

The configuration target. You must set the target to country when specifying a country code in the rule.

value?: string

The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to IP Access rules: Parameters.

mode: "block" | "challenge" | "whitelist" | 2 more

Body param: The action to apply to a matched request.

One of the following:
"block"
"challenge"
"whitelist"
"js_challenge"
"managed_challenge"
description?: string

Body param: An informative summary of the rule. This value is sanitized and any tags will be removed.

maxLength1024
paused?: boolean

Body param: When true, indicates that the rule is currently paused.

ReturnsExpand Collapse
UARuleUpdateResponse { id, configuration, description, 2 more }
id?: string

The unique identifier of the User Agent Blocking rule.

maxLength32
configuration?: Configuration { target, value }

The configuration object for the current rule.

target?: string

The configuration target for this rule. You must set the target to ua for User Agent Blocking rules.

value?: string

The exact user agent string to match. This value will be compared to the received User-Agent HTTP header value.

description?: string

An informative summary of the rule.

maxLength1024
mode?: "block" | "challenge" | "js_challenge" | "managed_challenge"

The action to apply to a matched request.

maxLength12
One of the following:
"block"
"challenge"
"js_challenge"
"managed_challenge"
paused?: boolean

When true, indicates that the rule is currently paused.

Update a User Agent Blocking rule

import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

const uaRule = await client.firewall.uaRules.update('372e67954025e0ba6aaa6d586b9e0b59', {
  zone_id: '023e105f4ecef8ad9ca31a8372d0c353',
  configuration: {},
  mode: 'challenge',
});

console.log(uaRule.id);
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "372e67954025e0ba6aaa6d586b9e0b59",
    "configuration": {
      "target": "ua",
      "value": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/603.2.4 (KHTML, like Gecko) Version/10.1.1 Safari/603.2.4"
    },
    "description": "Prevent access from abusive clients identified by this User Agent to mitigate a DDoS attack",
    "mode": "js_challenge",
    "paused": false
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "372e67954025e0ba6aaa6d586b9e0b59",
    "configuration": {
      "target": "ua",
      "value": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/603.2.4 (KHTML, like Gecko) Version/10.1.1 Safari/603.2.4"
    },
    "description": "Prevent access from abusive clients identified by this User Agent to mitigate a DDoS attack",
    "mode": "js_challenge",
    "paused": false
  },
  "success": true
}